package org.mortbay.ijetty.console;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

public class FileReader {
	public static String readFile(String path, String lineSplit) {
		FileInputStream fis;
		String fileContent = "";
		try {
			fis = new FileInputStream(path);
			InputStreamReader isr = new InputStreamReader(fis);
			BufferedReader br = new BufferedReader(isr);
			String line = br.readLine();
			while (line != null) {
				fileContent += (line + lineSplit);
				line = br.readLine();
			}
			br.close();
			isr.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return fileContent;
	}

	public static String readFile(String path, String lineSplit, int startLine,
			int endLine) {
		FileInputStream fis;
		String fileContent = "";
		try {
			fis = new FileInputStream(path);
			InputStreamReader isr = new InputStreamReader(fis);
			BufferedReader br = new BufferedReader(isr);
			int i = 0;
			String line = br.readLine();
			i++;
			while (line != null) {
				if (i >= startLine && i <= endLine) {
					fileContent += (line + lineSplit);
				}
				line = br.readLine();
			}
			br.close();
			isr.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return fileContent;
	}

	public static List<String> readFile(String path) {
		List<String> list = new ArrayList<String>();
		FileInputStream fis;
		try {
			fis = new FileInputStream(path);
			InputStreamReader isr = new InputStreamReader(fis);
			BufferedReader br = new BufferedReader(isr);
			String line = br.readLine();
			while (line != null) {
				list.add(line);
				line = br.readLine();
			}
			br.close();
			isr.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return list;
	}

	public static void main(String[] args) {
		List<String> list = FileReader.readFile("pom.xml");
		for (String line : list) {
			System.out.println(line);
		}
	}
}
