package org.mortbay.ijetty.console;

import java.io.BufferedReader;
import java.io.CharArrayWriter;
import java.io.IOException;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import android.content.ContentResolver;
import android.content.Context;
import android.location.LocationManager;

public class RestServlet extends HttpServlet {
	ServletContext sc;
	Context androidContext;
	ContentResolver resolver;
	LocationManager locationManager;
	ServletConfig config;

	@Override
	public void init(ServletConfig config) throws ServletException {
		super.init(config);
		this.config = config;
		sc = super.getServletContext();
		Constant.setPath(sc.getRealPath(""));
		androidContext = (android.content.Context) config.getServletContext()
				.getAttribute("org.mortbay.ijetty.context");
		locationManager = (LocationManager) androidContext
				.getSystemService(Context.LOCATION_SERVICE);
	}

	@Override
	protected void doDelete(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		try {
			ServletOutputStream stream = resp.getOutputStream();
			String className = Configurator.getClassName(req.getRequestURI(),
					"DELETE");
			String methodName = Configurator.getMethodName(req.getRequestURI(),
					"DELETE");
			Class<?> serviceClass = Class.forName(className);
			Method method = serviceClass.getMethod(methodName, String.class);
			StringBuffer requestBuffer = new StringBuffer();
			BufferedReader br = req.getReader();
			CharArrayWriter caw = new CharArrayWriter();
			char[] cArray = new char[4096];
			while (br.read(cArray) > 0) {
				caw.write(cArray);
			}
			char[] finalCArray = caw.toCharArray();
			requestBuffer.append(finalCArray);
			String requestMessage = requestBuffer.toString();
			String result = (String) method.invoke(serviceClass.newInstance(),
					requestMessage);
			stream.print(result);
			stream.flush();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			e.printStackTrace();
		} catch (InstantiationException e) {
			e.printStackTrace();
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
		} catch (SecurityException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
	}

	@Override
	protected void doGet(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		try {
			ServletOutputStream stream = resp.getOutputStream();
			String className = Configurator.getClassName(req.getRequestURI(),
					"GET");
			String methodName = Configurator.getMethodName(req.getRequestURI(),
					"GET");
			Class<?> serviceClass = Class.forName(className);
			Method method = serviceClass.getMethod(methodName, String.class,
					ServletConfig.class);
			String result = (String) method.invoke(serviceClass.newInstance(),
					req.getRequestURL().toString(), config);
			// method=demo.getMethod(methodName, String.class,int.class);
			// method.invoke(serviceClass.newInstance(),"Rollen",20);
			stream.print(result);
			stream.flush();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			e.printStackTrace();
		} catch (InstantiationException e) {
			e.printStackTrace();
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
		} catch (SecurityException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
	}

	@Override
	protected void doPost(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		try {
			ServletOutputStream stream = resp.getOutputStream();
			String className = Configurator.getClassName(req.getRequestURI(),
					"POST");
			String methodName = Configurator.getMethodName(req.getRequestURI(),
					"POST");
			Class<?> serviceClass = Class.forName(className);
			Method method = serviceClass.getMethod(methodName, String.class);
			StringBuffer requestBuffer = new StringBuffer();
			BufferedReader br = req.getReader();
			CharArrayWriter caw = new CharArrayWriter();
			char[] cArray = new char[4096];
			while (br.read(cArray) > 0) {
				caw.write(cArray);
			}
			char[] finalCArray = caw.toCharArray();
			requestBuffer.append(finalCArray);
			String requestMessage = requestBuffer.toString();
			// String result = (String)
			// method.invoke(serviceClass.newInstance(),
			// requestMessage);
			long t1 = System.currentTimeMillis();
			String[] stringArray = requestMessage.split("&");
			String s1 = stringArray[stringArray.length - 1];
			String s2 = stringArray[stringArray.length - 2];
			String s = s1 + s2;
			long t2 = System.currentTimeMillis();
			long delay = t2 - t1;
			stream.print(delay);
			stream.flush();
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
		} catch (SecurityException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
	}

	@Override
	protected void doPut(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		try {
			ServletOutputStream stream = resp.getOutputStream();
			String className = Configurator.getClassName(req.getRequestURI(),
					"PUT");
			String methodName = Configurator.getMethodName(req.getRequestURI(),
					"PUT");
			Class<?> serviceClass = Class.forName(className);
			Method method = serviceClass.getMethod(methodName, String.class);
			StringBuffer requestBuffer = new StringBuffer();
			BufferedReader br = req.getReader();
			CharArrayWriter caw = new CharArrayWriter();
			char[] cArray = new char[4096];
			while (br.read(cArray) > 0) {
				caw.write(cArray);
			}
			char[] finalCArray = caw.toCharArray();
			requestBuffer.append(finalCArray);
			String requestMessage = requestBuffer.toString();
			String result = (String) method.invoke(serviceClass.newInstance(),
					requestMessage);
			stream.print(result);
			stream.flush();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			e.printStackTrace();
		} catch (InstantiationException e) {
			e.printStackTrace();
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
		} catch (SecurityException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
	}

	private static final long serialVersionUID = -3260335451390691568L;
}
