package residenceAgent;

/**
 * Support for the developemnt of application service for the invocation of
 * mobile agent. The application specific service implemented by the application
 * programmer have to implement this interface.
 * 
 * Deployment method of application specific service to one node: in the
 * application JAVA project, implement the service class which implements this
 * interface. For example, mobileAgent.applicationService.PictureService class.
 * In the ResidenceAgentInit.at file which init the running environment of the
 * framework for one node, use the following code to deploy this service to the
 * residence agent for the invocation of mobile agent:<br/>
 * def pictureService :=
 * jlobby.residenceAgent.applicationService.demo.PictureService.new();<br/>
 * residenceAgent.addApplicationService("pictureService", pictureService);<br/>
 * 
 * @author Xiping Hu
 * 
 */
public interface IApplicationService {
	/**
	 * execute method, this method can be invoked by the mobile agent when it
	 * comes to one node.
	 * 
	 * @return the result of the service execution, when this returned to the
	 *         mobile agent, it can decide whether to take it away or leave it
	 *         at the node.
	 */
	public String executeService();
	
}
